function [Ref] = findRef(points)
    %points = [-0.2,0.1,0.6,-0.4;0.1,0,2,0.8];
    X = points(1,:);
    Y = points(2,:);
    Z = points(3,:);
    
    Xc = mean(X);
    Yc = mean(Y);
    Zc = mean(Z);
    c = [Xc,Yc,Zc];
    L = zeros(1,8);
    for i=1:4
        p = [points(1,i),points(2,i),points(3,i)];
        Op = c - p;
        L(i) = norm(Op);
    end
    a = 2*max(L);
    
    p1 = [Xc+a,Yc];
    p2 = [Xc,Yc-a];
    
    L = zeros(1,4);
    for i = 1:4
        O = [X(i),Y(i)];
        Op1 = O-p1;
        Op2 = O-p2;
        L(i) = norm(Op1)+norm(Op2);
    end
    Ref = find(L==min(L));
    
%     plot(X,Y,Xc,Yc,'kx'),hold on
%     plot(p1(1),p1(2),'kx',p2(1),p2(2),'kx')
%     plot(X(2),Y(2),'ro')
end

