function [ElemConn] = getConnectivity2(Nelm,ElemInfo)
disp(' DETERMING CONNECTIVITY       :    STARTED ****');  
    f  = [1,2,3,4,5,6];
    F1 = [1,2,5,6];
    F2 = [2,3,6,7];
    F3 = [3,4,7,8];
    F4 = [1,4,5,8];
    F5 = [1,2,3,4];
    F6 = [5,6,7,8];
    Faces = [F1;F2;F3;F4;F5;F6];

    ElemConn = ones(6*Nelm,4);
    % ------------------------------ Create Connectivity Matrix
    for e=1:Nelm
        start = 6*e-5;a=1;
        for i=start:start+5   
            ElemConn(i,1) = e;
            ElemConn(i,2) = f(a);
            a=a+1;
        end
    end

    %------------------------------- Determine Connectivity
    for j = 1:length(ElemConn(:,1)) 
            e = ElemConn(j,1);
            f = ElemConn(j,2);
            R = zeros(8,1);
            C = zeros(8,1);
            for i =1:4
                [R1,C1] = find(ElemInfo(:,2:9) == ElemInfo(e,Faces(f,i)+1));
                                   
                R(1:length(R1),i) = R1;
                C(1:length(C1),i) = C1;
            end

            % Determine the element connecting to face "f"
            s = size(R);
            elm=0;  %  <---- if none is found, zero means no element connection
            for i=1:s(1)*s(2)
                if R(i) ~= 0 & R(i) ~= e
                    a = (R==R(i));
                    if sum(sum(a))==4 
                        elm = R(i);
                    end
                end
            end
            % Determine face of element connecting to desired element
            if elm==0
                face = 0;
            else
                b = find(R==elm);
                c = C(b);
                c = c';
                c = sort(c);
                for i=1:6
                    if Faces(i,:)==c
                        face = i;
                    end
                end
            end
            ElemConn(j,3) = elm;
            ElemConn(j,4) = face;
    end
disp('                                   DONE');
pause(.25); 
end