function [after] = orderElem2(before)

%================= Determine top/bottom Pts via Zc & a Ref point (O)

Xc = mean(before(1,:));
Yc = mean(before(2,:));
Zc = mean(before(3,:));
c = [Xc,Yc,Zc];

L = zeros(1,8);
for i=1:8
    p = [before(1,i),before(2,i),before(3,i)];
    Op = c - p;
    L(i) = norm(Op);
end

a = 2*max(L);

Bottom = zeros(3,4);

O = [Xc,Yc,Zc-2*a];   % Reference Point
L = zeros(1,8);
    for i = 1:8
        p = [before(1,i),before(2,i),before(3,i)];
        Op = O-p;
        L(i) = norm(Op);
    end
    b = 1;
    for i = 1:length(L)
        L(2,i) = b;
        b = b +1;
    end
    for i = 1:4
        r = find(L(1,:) == min(L(1,:)));
        if r > 1
            for j = 1:length(r)-1
                r(j)=[];
            end
        end
        Bottom(:,i) = before(:,L(2,r));
        L(:,r)=[];
    end
Top = before(:,L(2,:));

%================== Next, Find centroid of "2D element" formed by bottom
%                   points

Xcb = mean(Bottom(1,:));
Ycb = mean(Bottom(2,:));
Zcb = mean(Bottom(3,:));
Bc = [Xcb,Ycb,Zcb];

%================== Locate Reference Pt, This will be "Pt1" in the final
%                   element ordering

Ref = findRef(Bottom);
BotAfter = zeros(3,1);

for j=1:4
    Pt1 = Bottom(:,Ref);          %  REFERENCE POINT 
    BotAfter(:,j) = Pt1;
    Dt = zeros(3,1);
    for i=1:4
        OA = [Pt1(:,1)-Bc'];
        OB = [Bottom(:,i)-Bc'];
        Dt(:,i) = cross(OA,OB);
    end
        Dt(1,:)=[];
        Dt(1,:)=[];
        a = find(Dt>0);
        if length(a)>1
            OA = [Bottom(:,a(1))-Bc'];
            OB = [Bottom(:,a(2))-Bc'];
            Dt2 = cross(OA,OB);
            Dt2(1,:) = [];
            Dt2(1,:) = [];
            if Dt2 < 0
                Ref = a(2);
            else
                Ref = a(1);
            end
        else
            Ref = find(Dt == max(Dt));
        end
end

%=================== Next, Repeat above for the top "2D element"

Xct = mean(Top(1,:));
Yct = mean(Top(2,:));
Zct = mean(Top(3,:));
Tc = [Xct,Yct,Zct];


Ref = findRef(Top);
TopAfter = zeros(3,1);
for j=1:4
    Pt1 = Top(:,Ref) ;         %  REFERENCE POINT 
    TopAfter(:,j) = Pt1;
    Dt = zeros(3,1);
    for i=1:4
        OA = [Pt1(:,1)-Tc'];
        OB = [Top(:,i)-Tc'];
        Dt(:,i) = cross(OA,OB);
    end
        Dt(1,:)=[];
        Dt(1,:)=[];
        
        a = find(Dt>0);
        
        if length(a)>1
            OA = [Top(:,a(1))-Tc'];
            OB = [Top(:,a(2))-Tc'];
            Dt2 = cross(OA,OB);
            Dt2(1,:) = [];
            Dt2(1,:) = [];
            if Dt2 < 0
                Ref = a(2);
            else
                Ref = a(1);
            end
        else
            Ref = find(Dt == max(Dt));
        end
end

%=================== With the top and bottom ordered, assemble final form
after(:,1:4)=BotAfter;
after(:,5:8)=TopAfter;

end